#!/bin/sh
#
# koha-upgrade-schema -- Upgrade the DB schema for Koha instances.
# Copyright 2010  Catalyst IT, Ltd
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set -e

# Read configuration variable file if it is present
[ -r /etc/default/koha-common ] && . /etc/default/koha-common

# include helper functions
if [ -f "/usr/share/koha/bin/koha-functions.sh" ]; then
    . "/usr/share/koha/bin/koha-functions.sh"
else
    echo "Error: /usr/share/koha/bin/koha-functions.sh not present." 1>&2
    exit 1
fi

# Optionally use alternative paths for a dev install
adjust_paths_dev_install $1
if [ "$DEV_INSTALL" = "" ]; then
    CGI_PATH=$KOHA_HOME/intranet/cgi-bin
else
    CGI_PATH=$KOHA_HOME
fi

for name in "$@"
do
    if is_instance $name; then
        echo "Upgrading database schema for $name"
        if KOHA_CONF="/etc/koha/sites/$name/koha-conf.xml" \
        PERL5LIB=$PERL5LIB \
        "$CGI_PATH/installer/data/mysql/needs_update.pl"; then
            KOHA_CONF="/etc/koha/sites/$name/koha-conf.xml" \
            PERL5LIB=$PERL5LIB \
            "$CGI_PATH/installer/data/mysql/updatedatabase.pl"
        else
            echo "No database change required"
        fi
    else
        die "Error: Invalid instance name $name"
    fi
done
